<?php
if(file_exists('log.php')) require 'log.php'; else define('LOG2F','');

function newFLst($d, $fLst){
  if(DIRS_ONLY) $aDirLst = explode("\n",DIRS_ONLY) ; else $aDirLst = array(0=>$d);
  foreach($aDirLst as $d){
    $d = trim($d, "\r\n");
    saveFLst($d, $fLst);
  }
}
/**
 * recursive get all files from $d and save to $fLst file
 *
 * @param string $d source directory
 * @praram string $fLst file listing
 * @praram int $cnt  count files
 * @return array dirlist
 */
function saveFLst($d, $fLst) {
  $rLst = fopen($fLst, "a");

  $aLst = $a = array();

  if ($r = opendir($d)) {


    while (false !== ($f = readdir($r))) {
      if ($f == '.' || $f == '..' ) {
        continue;
      }

      $fPath = $d . DIRECTORY_SEPARATOR . $f;
      if(!canDLst($fPath)) continue;
      if (is_file($fPath) && canFLst($fPath, $a)) {

        $s = af2s($a, $fPath);
        fwrite($rLst, $s);
      } elseif (is_dir($fPath)) {

        //$aLst = array_merge($aLst, saveFLst($fPath, $fLst));
        $aLst += saveFLst($fPath, $fLst);
      }
    }
    closedir($r);
  }


  fclose($rLst);
  return $aLst;
}

function canDLst($d){
  if (DIRS_EXCLUDE) {
    $aMask = lst(DIRS_EXCLUDE);
    foreach($aMask as $v) if (strpos('.'.$d, $v)) return false;
  }
  return true;
}

/**
 * filter for files
 * @param string $f filename
 * @param array $a fileinfo return
 * @return bool
 */
function canFLst($f, &$a) {

  /*
  filenames & dirnames  separated semicolon
  */


  if (FILES_EXCLUDE) {
    $fName = basename($f);
    $aMask = lst(FILES_EXCLUDE);
    foreach ($aMask as $v) if (fnmatch($v, $fName)) return false;
  }

  $a = stat($f);

  if ($a['size'] > FILE_SIZE_MAX) return false;

  return true;
}

/**
 * @param $fLst
 * @return array
 */
function getWarnLst($fLst, &$cnt) {
  $r = fopen($fLst, "r");
  $a0 = array();
  $aScanSign = Sign2A('(');
  $aScanSignCase = lst(SCAN_SIGN_CASE);
  while (!feof($r)) {
    $sInfo = fgets($r);
    $a = s2af($sInfo);
    if ($a['f']) {
      $cnt++;
      $s = file_get_contents($a['f']);
      if (hasCaseWarnSign($s, $aScanSignCase)) {
        $a0[] = $a;
      } else { //nocase
        $s = strtolower($s);
        if (hasWarnSign($s, $aScanSign)) $a0[] = $a;
      }
    }
  }
  fclose($r);
  return $a0;
}

/**
 * @param $s string  !must be lowercase
 * @return bool
 */
function hasWarnSign($s, $aScanSign) {
  //del the opening brace for functions ex: eval(
  //need for finding "eval (" and "eval("
  foreach ($aScanSign as $sSign) if ($sSign && strpos($s, $sSign) !== false) return true;
  return false;
}

/**
 * hasCaseWarnSign CASE sensitive search
 * @param $s string  !must be lowercase
 * @return bool
 */
function hasCaseWarnSign($s, $aScanSignCase) {
  foreach ($aScanSignCase as $sSign) if (strpos($s, $sSign) !== false) return true;
  return false;
}

/**
 * @param $fLst
 * @param $sSign
 * @return array
 */
function getSearchLst($fLst, $sSearch, $kSort = 'f', &$cntF) {
  if (!trim($sSearch)) return array();
  $sSearch = strtolower(base64_decode($sSearch));
  $r = fopen($fLst, "r");
  $a0 = $aSort = array();
  $i = $cntF = 0;
  while (!feof($r)) {
    $sInfo = fgets($r);
    $a = s2af($sInfo);
    if ($a['f']) {
      $cntF++;
      $s = is_file($a['f']) ? strtolower(file_get_contents($a['f'])) : '';
      if (strpos($s, $sSearch) !== false) {
        $i++;
        $a['lstSign'] = '';
        $a0[$i] = $a;
        $aSort[$i] = $a[$kSort];

        //multisearch ;;; separate
      } elseif(strpos($sSearch,';;;')){
        $aSearch = explode(';;;', $sSearch);
        $bSearch = true;
        foreach($aSearch as $vSearch) if(trim($vSearch)){
          if (strpos($s, $vSearch) === false) $bSearch = false;
        }
        if($bSearch){
          $i++;
          $a['lstSign'] = 'multisearch '.htmlspecialchars($sSearch);
          $a0[$i] = $a;
          $aSort[$i] = $a[$kSort];
        }
      }
    }
  }
  fclose($r);
  array_multisort($aSort, strpos($kSort, 'ux') !== false ? SORT_DESC : SORT_ASC, $a0);
  return $a0;
}

/**
 * Convert string to fileinfo array($atime, $ctime, $mtime, $size, $f)
 * @param $s string
 * @return array fileinfo array($atime, $ctime, $mtime, $size, $f)
 */
function s2af($s) {
  $a = array();
  sscanf($s, "%d;%d;%d;%d;;%s\n", $a['uxAccess'], $a['uxCreate'], $a['uxModify'], $a['iSize'], $a['f']);
  $a['f'] = rtrim(substr($s, strpos($s, ';;') + 2));
  $a['sExt'] = pathinfo($a['f'], PATHINFO_EXTENSION);

  return $a;
}

/**
 * Convert array to fileinfo string
 * @param $f string filepath
 * @param $a array fileinfo array($atime, $ctime, $mtime, $size, $f)
 * @return string
 */
function af2s($a, $f) {
  $s = sprintf("%s;%s;%s;%s;;%s\n", $a['atime'], $a['ctime'], $a['mtime'], $a['size'], $f);
  return $s;
}

/**
 * @param $aWarnLst array
 * @return array
 */
function getFilteredWarnLst($aWarnLst, $kSort = 'f') {
  $a = $aSort = array();
  $aScanSignCase = lst(SCAN_SIGN_CASE);
  $aScanSign = Sign2A();
  foreach ($aWarnLst as $k => $a0) {
    $lstSign = '';
    $s = file_get_contents($a0['f']);
    foreach ($aScanSignCase as $sSign) {
      if (strpos($s, $sSign) !== false) $lstSign .= $sSign . ',';
    }
    $s = strtolower($s);
    //  Removes single line '//' comments, treats blank characters
    $s = preg_replace('![ \t]*//.*[ \t]*[\r\n]!', '', $s);

    //remove multi line comments
    $s = preg_replace('!/\*.*?\*/!s', '', $s);

    // Compress newlines after opening braces and strip spaces before and after brace
    $s = preg_replace('/\s*\(\s*\n?\s*/', '(', $s);

    //remove all concatent string
    $s = preg_replace("/[\"']{1}[ ]{0,}\.[ ]{0,}[\"']{1}/", '', $s);

    foreach ($aScanSign as $sSign) {
      if ($sSign && strpos($s, $sSign) !== false) $lstSign .= $sSign . ',';
    }
    if ($lstSign) {
      $a0['lstSign'] = rtrim($lstSign, ',');
      $a[$k] = $a0;
      $aSort[$k] = $a0[$kSort];
    }
  }
  array_multisort($aSort, (strpos($kSort, 'ux') !== false) ? SORT_DESC : SORT_ASC, $a);
  return $a;
}

/**
 * filter input var
 * @param $k string
 * @param $canLst string list of valid values
 * @param string $sInput input method ex: _GET, _POST, _COOKIE
 * @return mixed
 */
function filterV($k, $canLst, $sInput = '_GET') {
  $a = explode(',', $canLst);
  return isset($GLOBALS[$sInput][$k]) && in_array($GLOBALS[$sInput][$k], $a) ? $GLOBALS[$sInput][$k] : $a[0];
}

function viewF($f, &$af) {
  if (!is_file($f)) return '';
  $r = fopen($f, 'r');
  $a = fstat($r);
  //$a['uxAccess'], $a['uxCreate'], $a['uxModify'], $a['iSize']
  $af = array('uxAccess' => $a['atime'], 'uxCreate' => $a['ctime'], 'uxModify' => $a['mtime'], 'iSize' => $a['size']);
  $af['f'] = $f;
  $s0 = fread($r, $a['size']);

  $s = strtolower($s0);

  //  Removes single line '//' comments, treats blank characters
  $s = preg_replace('![ \t]*//.*[ \t]*[\r\n]!', '', $s);

  //remove multi line comments
  $s = preg_replace('!/\*.*?\*/!s', '', $s);

  // Compress newlines after opening braces and strip spaces before and after brace
  $s = preg_replace('/\s*\(\s*\n?\s*/', '(', $s);


  $aSign = array();
  $aSignLst = Sign2A() + lst(strtolower(SCAN_SIGN_CASE));
  foreach ($aSignLst as $sSign) {
    $cnt = $sSign ? substr_count($s, $sSign) : 0 ;
    if ($cnt) $aSign[$sSign] = $cnt;
  }
  $af['aLst'] = $aSign;
  $af['lstSign'] = '';
  fclose($r);
  return $s0;
}

function delF($f) {
  if (DIR_SAFE) {
    $aMask = explode(';', DIR_SAFE);
    foreach ($aMask as $v) if (fnmatch($v, $f)) return null;
  }

  //chmod(dirname($f),0755);	
  //chmod($f,0644);
  if(LOG2F) log2f($f, 'delF');
  return unlink($f);
}

function patchFF($f, $fVir, $sReplace = '') {
  $sSign = file_get_contents($fVir);
  if (DIR_SAFE) {
    $aMask = explode(';', DIR_SAFE);
    foreach ($aMask as $v) if (fnmatch($v, $f)) return null;
  }
  $s = file_get_contents($f);
  if(is_file(FILE_REPLACE)) $sReplace = file_get_contents(FILE_REPLACE);
  $s = str_replace($sSign, $sReplace, $s);
  //chmod(dirname($f),0755);
  //chmod($f,0644);
  if(LOG2F) log2f($f, 'patchFF');
  return file_put_contents($f, $s);
}

function patchPreg($f) {
  if (DIR_SAFE) {
    $aMask = explode(';', DIR_SAFE);
    foreach ($aMask as $v) if (fnmatch($v, $f)) return null;
  }
  if (!FS_PREG) return null;
  $s = file_get_contents($f);
  $s = preg_replace(FS_PREG, '', $s);
  if(LOG2F) log2f($f, 'patchPreg');
  return file_put_contents($f, $s);
}

/**
 * @param array $a file type
 * @param string $k array key
 * @param string $sSign ">" , "<", OR "=="
 * @param string $sAssert comparison value
 * @return bool
 */
function assertF($a, $k = '', $sSign = '', $sAssert = '') {
  $sAssert = trim($sAssert);
  if (!$sAssert || !isset($a[$k])) return TRUE; //no_filter
  $sVal = $a[$k];

  if ($k == 'sExt') {
    $sVal = "'$sVal'";
    $sAssert = "'$sAssert'";
  }

  return @assert($sVal . $sSign . $sAssert);
}

function delExif($f) {
  $img = imagecreatefromjpeg($f);
  $b = imagejpeg($img, $f, 100);
  imagedestroy($img);
  return $b;
}

function urlSafeB64Encode($data) {
  $b64 = base64_encode($data);
  $b64 = str_replace(array('+', '/', '\r', '\n', '='),
    array('-', '_'),
    $b64);
  return $b64;
}

function urlSafeB64Decode($b64) {
  $b64 = str_replace(array('-', '_'),
    array('+', '/'),
    $b64);
  return base64_decode($b64);
}

//shugar
function lst($lst, $sSep = ';') {
  return explode($sSep, $lst);
}

/**
 * Sign2S
 * @param $Sign
 * @return string
 */
function Sign2A($chrDel = ''){
  $sSign = file_get_contents('sign.vir');
  $s = SCAN_SIGN.';'.str_rot13(strrev($sSign));
  if($chrDel) $s = str_replace($chrDel, '', $s);
  return lst(strtolower($s));
}

function dbg2f($message, $label = null) {
  $sf = 'dbg2f.log';
  $s = date('Y-m-d H:i:s');
  $s .= $label ? $label . ': ' : '';
  $s .= print_r($message, true);
  file_put_contents($sf, $s . "\n\n", FILE_APPEND);
  chmod($sf, 0664);
}
//if(!function_exists('log2f')) function log2f($a,$b){;};



